# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class DirectAccessUrl(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'content_url': 'str',
        'attachment': 'bool',
        'expires_at': 'datetime'
    }

    attribute_map = {
        'content_url': 'contentUrl',
        'attachment': 'attachment',
        'expires_at': 'expiresAt'
    }

    def __init__(self, content_url=None, attachment=None, expires_at=None, _configuration=None):  # noqa: E501
        """DirectAccessUrl - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._content_url = None
        self._attachment = None
        self._expires_at = None
        self.discriminator = None

        self.content_url = content_url
        if attachment is not None:
            self.attachment = attachment
        if expires_at is not None:
            self.expires_at = expires_at

    @property
    def content_url(self):
        """Gets the content_url of this DirectAccessUrl.  # noqa: E501

        The direct access URL of a binary content  # noqa: E501

        :return: The content_url of this DirectAccessUrl.  # noqa: E501
        :rtype: str
        """
        return self._content_url

    @content_url.setter
    def content_url(self, content_url):
        """Sets the content_url of this DirectAccessUrl.

        The direct access URL of a binary content  # noqa: E501

        :param content_url: The content_url of this DirectAccessUrl.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and content_url is None:
            raise ValueError("Invalid value for `content_url`, must not be `None`")  # noqa: E501

        self._content_url = content_url

    @property
    def attachment(self):
        """Gets the attachment of this DirectAccessUrl.  # noqa: E501

        Flag to control the download method, **true** for attachment URL, **false** for embedded URL  # noqa: E501

        :return: The attachment of this DirectAccessUrl.  # noqa: E501
        :rtype: bool
        """
        return self._attachment

    @attachment.setter
    def attachment(self, attachment):
        """Sets the attachment of this DirectAccessUrl.

        Flag to control the download method, **true** for attachment URL, **false** for embedded URL  # noqa: E501

        :param attachment: The attachment of this DirectAccessUrl.  # noqa: E501
        :type: bool
        """

        self._attachment = attachment

    @property
    def expires_at(self):
        """Gets the expires_at of this DirectAccessUrl.  # noqa: E501

        The direct access URL would become invalid when the expiry date is reached  # noqa: E501

        :return: The expires_at of this DirectAccessUrl.  # noqa: E501
        :rtype: datetime
        """
        return self._expires_at

    @expires_at.setter
    def expires_at(self, expires_at):
        """Sets the expires_at of this DirectAccessUrl.

        The direct access URL would become invalid when the expiry date is reached  # noqa: E501

        :param expires_at: The expires_at of this DirectAccessUrl.  # noqa: E501
        :type: datetime
        """

        self._expires_at = expires_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DirectAccessUrl, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DirectAccessUrl):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DirectAccessUrl):
            return True

        return self.to_dict() != other.to_dict()
